/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.stimmeingabe.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.stimmeingabe.entity.ZwischensummeEingabe;
import de.ivu.elect.business.stimmeingabe.entity.ZwischensummeEingabeUK;

public abstract class AbstractZwischensummeEingabeDAO extends de.ivu.elect.jee.entity.AbstractDAO<ZwischensummeEingabe,
      de.ivu.elect.business.stimmeingabe.entity.StimmeingabePK
  , ZwischensummeEingabeUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractZwischensummeEingabeDAO.class);

  public AbstractZwischensummeEingabeDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.stimmeingabe.entity.StimmeingabePK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public ZwischensummeEingabe findByPrimaryKey(
      de.ivu.elect.business.stimmeingabe.entity.StimmeingabePK
    pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected ZwischensummeEingabe findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(ZwischensummeEingabe.class, id);
  }



     /**
      * Name: ErgebniseingangNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT ze FROM ZwischensummeEingabe ze WHERE ze.ergebniseingang =(?1)<br>
      * SQL: <br>
      */
     public java.util.List<ZwischensummeEingabe> findByErgebniseingang( @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingangCheckedAndAttached =  checkAndAttach(ergebniseingang, de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang.class, "ergebniseingang"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ZWISCHENSUMME_EINGABE.Ergebniseingang")
                              .setParameter(1, ergebniseingangCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("ZwischensummeEingabe, findByErgebniseingang - NonUniqueResultException, Parameter: "
           + ", ergebniseingang:'"+ergebniseingang+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebniseingang(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.stimmeingabe.entity.ZwischensummeEingabeUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.stimmeingabe.entity.ZwischensummeEingabeUK uk,
      de.ivu.elect.business.stimmeingabe.entity.StimmeingabePK
    pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.stimmeingabe.entity.ZwischensummeEingabe findByUK(de.ivu.elect.business.stimmeingabe.entity.ZwischensummeEingabeUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}